import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type {
  ThinkUsersVipCancleLog,
  ThinkUsersVipCancleLogParam
} from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询VIP卡退卡日志
 */
export async function pageThinkUsersVipCancleLog(
  params: ThinkUsersVipCancleLogParam
) {
  const res = await request.get<ApiResult<PageResult<ThinkUsersVipCancleLog>>>(
    THINK_API_URL + '/think/think-users-vip-cancle-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询VIP卡退卡日志列表
 */
export async function listThinkUsersVipCancleLog(
  params?: ThinkUsersVipCancleLogParam
) {
  const res = await request.get<ApiResult<ThinkUsersVipCancleLog[]>>(
    THINK_API_URL + '/think/think-users-vip-cancle-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加VIP卡退卡日志
 */
export async function addThinkUsersVipCancleLog(data: ThinkUsersVipCancleLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-vip-cancle-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改VIP卡退卡日志
 */
export async function updateThinkUsersVipCancleLog(
  data: ThinkUsersVipCancleLog
) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-vip-cancle-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除VIP卡退卡日志
 */
export async function removeThinkUsersVipCancleLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-vip-cancle-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除VIP卡退卡日志
 */
export async function removeBatchThinkUsersVipCancleLog(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-vip-cancle-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询VIP卡退卡日志
 */
export async function getThinkUsersVipCancleLog(id: number) {
  const res = await request.get<ApiResult<ThinkUsersVipCancleLog>>(
    THINK_API_URL + '/think/think-users-vip-cancle-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
